'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _visitors = require('./visitors');

var _util = require('./util');

var plugin = function plugin() {
  return {
    manipulateOptions: function manipulateOptions(opts, parserOptions) {
      parserOptions.plugins.push('classProperties');
      parserOptions.plugins.push('jsx');
      parserOptions.plugins.push('objectRestSpread');
      parserOptions.plugins.push('flow');
    },
    pre() {
      this.store = new _util.Store();
    },
    visitor: {
      Program(programPath, _ref) {
        var opts = _ref.opts;

        programPath.traverse(_visitors.importVisitor, this.store);

        if (!this.store.hasImport) return;

        programPath.traverse(_visitors.entryVisitor, this.store);
        programPath.traverse(_visitors.propVisitor, this.store);

        (0, _util.appendProps)(this.store.getEntries(), opts);
      }
    }
  };
};

exports.default = plugin;