'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createClassProperty = exports.createFunctionProperty = undefined;

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var createEntriesArray = function createEntriesArray(props) {
  var entries = _lodash2.default.uniq(props).sort().map(function (prop) {
    return t.stringLiteral(prop);
  });

  return t.arrayExpression(entries);
};

var createFunctionProperty = exports.createFunctionProperty = function createFunctionProperty(identifier, props) {
  var left = t.memberExpression(t.identifier(identifier), t.identifier('handledProps'));
  var right = createEntriesArray(props);

  return t.expressionStatement(t.assignmentExpression('=', left, right));
};

var createClassProperty = exports.createClassProperty = function createClassProperty(props) {
  var key = t.identifier('handledProps');
  var value = createEntriesArray(props);
  var property = t.classProperty(key, value);
  property.static = true;

  return property;
};